﻿namespace FileStorage
{
    public interface IFileStorage
    {

        /// <summary>
        /// 本地上传
        /// </summary>
        /// <param name="fileName"></param>
        /// <param name="length"></param>
        /// <param name="extraInfo"></param>
        /// <param name="fileData"></param>
        /// <param name="client"></param>
        /// <param name="isVerification">是否验证文件格式</param>
        /// <returns></returns>
        Task<FileMetadata> UploadAsync(string fileName, long length, string extraInfo, Stream fileData, string client, bool? isVerification);

        Task<Uri> GetFileUrlAsync(string id, string clientId);

        (Stream stream, string contentType,string fileName) DownLoadFile(string id);

        Task<bool> DelFileAsync(string id, string clientId);

        Task<string> GetFilePath(string id, string expires, string clientId, string signature);

        Task<string> GetFilePathAsync(string id, string clientId);

        Task<string> GetFilePathIndefinitely(string id, string expires, string clientId, string signature);

        Task<Uri> GetFileUrlIndefinitelyAsync(string id, string clientId);
	}
}
